int N = segments.size(); 

    
    vector<vector<int>> sortedSegments = segments; 
    sort(sortedSegments.begin(), sortedSegments.end(), [](const vector<int> &a, const vector<int> &b) {
        return a[1] < b[1]; 
    });

    
    priority_queue<pair<int, int>, vector<pair<int, int>>, greater<pair<int, int>>> minHeap;
    int min_cost = numeric_limits<int>::max(); 

    for (const auto &segment : sortedSegments) {
        int L = segment[0]; 
        int R = segment[1]; 
        int cost = segment[2]; 

        
        while (!minHeap.empty() && minHeap.top().first >= L) {
            minHeap.pop();
        }

        
        if (!minHeap.empty()) {
            int pairing_cost = minHeap.top().second * cost;
            min_cost = min(min_cost, pairing_cost); 
        }

        
        minHeap.push({R, cost}); 
    }

    return (min_cost != numeric_limits<int>::max()) ? min_cost : -1; 
}